<head>
    <meta charset="utf-8">
    <link REL="icon" HREF="favicon.ico">
    <title>Sansoori : environnement d'apprentissage de la ligne de commande basé sur les compétences</title>
    <style>
        BODY {
            --body: 40em;
            max-width: var(--body);
            font-family: sans-serif;
            line-height: 1.3em;
        }

        P,
        LI {
            text-align: justify
        }

        LI {
            margin-top: 0.2em;
        }

        H1,
        H2 {
            clear: both;
            line-height: 1.3em;
        }

        H1 {
            font-size: 150%;
            border: 1px solid #000;
            padding: 0.2em;
        }

        H2 {
            font-size: 120%;
            background: #FFF;
            border-bottom: 1px solid #000;
        }

        H3 {
            font-size: 100%;
        }

        TABLE {
            border-collapse: collapse;
            border-spacing: 0px;
        }

        TABLE TD {
            border: 1px solid #888;
            vertical-align: top;
        }

        TT,
        PRE {
            background: #FFE;
            border: 1px solid #880;
            font-family: monospace, monospace;
            font-size: 90%;
            overflow: hidden;
        }

        .figure {
            font-style: italic;
        }

        .figure P {
            margin: 0px;
        }

        @media screen {
            .figure {
                position: absolute;
                margin-left: calc(var(--body) + 1em);
                width: min-content;
            }

            .figure IMG {
                max-width: calc(100vw - var(--body) - 2em);
            }
        }

        @media print {
            BODY {
                --body: 100vw;
            }

            /* .figure {
                page-break-before: always;
            } */
        }
    </style>
</head>

<body>
    <h1>Sansoori : environnement d'apprentissage de la ligne de commande basé sur les compétences</h1>

    <p>
        Ce système est le successeur de plusieurs logiciels d'apprentissage du langage shell.
        Il corrige leurs points faibles et met l'accent sur la pratique plutôt que sur la théorie.
        En effet les étudiants doivent pouvoir utiliser immédiatement
        ce qu'ils apprennent dans les autres cours.
        Ce système peut s'appliquer à n'importe quel
        langage de commande ou même langage de programmation.
    </p>

    <p>
        L'ancien système (<a href="https://perso.univ-lyon1.fr/thierry.excoffier/QUENLIG/">QUENLIG</a>)
        coloriait syntaxiquement la réponse pendant la saisie
        et expliquait caractère par caractère comment la commande était interprétée par le shell.
        il rappelait aussi les questions et réponses précédentes
        qui pouvaient être utiles pour répondre à la question actuelle.
        L'expérience a montré que les étudiants de première année de licence
        ne tiennent compte ni des couleurs ni des messages même s'ils sont affichés en rouge.
        La quantité d'information étant trop grande ils ne lisent pas ce qu'il y a sur l'écran.
        Pour débloquer les étudiants complètement coincés à cause d'un point de détail,
        QUENLIG permet de lister les caractères en trop ou manquant dans leur réponse.
        Dès que les étudiants découvrent cette possibilité,
        ils commencent par regarder la liste et cherchent des anagrammes.
        Au final le système les aide tellement que les étudiants n'utilisent le shell
        que quand ils y sont contraints.
        En effet QUENLIG impose un délai avant de proposer une nouvelle réponse
        quand ils ont fait trop d'erreur.
    </p>

    <h2>La philosophie du système Sansoori</h2>

    <p>
        Sansoori est un serveur web affichant une page web contenant un terminal.
        Les retours à l'étudiant sont faits en temps réel en fonction de :
    </p>
    <ul>
        <li> Ce que tape l'étudiant.</li>
        <li> Ce que sélectionne l'étudiant sur l'écran.</li>
        <li> Ce que l'écran affiche.</li>
        <li> L'état réel du système. Ceci permet de valider une réponse
            de l'étudiant qui ne correspond pas du tout a ce qui était attendu.
        </li>
        <li> Et du temps que l'étudiant met pour répondre.</li>
    </ul>
    <p>
        Les exercices ont pour objectif de mettre les étudiants devant
        les problèmes qu'ils auront dans la réalité.
        L'aspect théorique n'est pas prioritaire car les étudiants ne mémorisent pas
        les solutions aux problèmes qu'ils n'ont pas rencontrés car ils n'en voient pas l'utilité.
    </p>

    <div class="figure">
        <p>
            Textes <b>encadrés : les compétences</b> avec le nombre de points,
            colorié en vert pour les compétences acquises (&ge;1 point)
        </p>
        <p>
            Label <b>non encadrés : les questions</b>.
            Les flèches entrantes indiquent les compétences nécessaires pour répondre
            et les sortantes les compétences qui pourront être validées.
            Le + indique le nombre de réussites et le - le nombre d'échecs.
        </p>
        <a href="xxx-graph.svg"><img src="xxx-graph.svg" style="width:40em"></a>
    </div>

    <p>
        Le système contient des <b>questions</b> avec des <b>compétences requises</b> nécessaires
        pour y répondre et des <b>compétences récoltées</b> si la question est validée.
        L'étudiant travaille sur la question jusqu'au moment où il réussit ou bien abandonne.
        Pendant qu'il travaille le système analyse ce qu'il fait et peut le guider en temps réel.
    </p>

    <p>
        À chaque <b>compétence</b> est associé un nombre de points positif ou nul.
        On considère la compétence acquise si sa valeur dépasse 1.
        On peut continuer à travailler même si toutes les compétences sont acquises.
        Une compétence qui vient juste d'être acquise possèdera 1 points,
        et sera perdue à la première erreur.
        Une compétence ne sera acquise solidement que si son nombre
        de points est suffisamment élevé et donc quelle a été démontrée
        par de nombreuses questions.
        Un étudiant qui ne commet aucune erreur va donc très rapidement
        débloquer les compétences les unes après les autres,
        il n'aura même pas à répondre à toutes les questions.
        Un étudiant qui commet des erreurs se verra proposer des questions
        pour réacquérir les compétences qu'il vient de perdre,
        cela ne sera pas forcément la même question que la première fois.
    </p>
    <table>
        <tr>
            <th rowspan=2></th>
            <th colspan=2>Évolution des points des compétences.</th>
        </tr>
        <tr>
            <td><b>Requises</b> par la question.<br>
                Le nombre de points change peu car la mesure de la compétence
                est indirecte.
            </td>
            <td><b>Récoltés</b> par la question.<br>
                Le nombre de points change beaucoup car la compétence
                est directement évaluée par la question.
            </td>
        </tr>
        <tr>
            <td style="text-align: right">Question échouée</td>
            <td> *0.9 car il est peut-être nécessaire de réviser.</td>
            <td> *0.5 car l'étudiant a oublié cette compétence.
            </td>
        </tr>
        <tr>
            <td style="text-align: right">Question réussie.</td>
            <td> *1.1 car il a su réutiliser une ancienne compétence.</td>
            <td> +1 car la compétence est considérée acquise.</td>
        </tr>
        <tr>
            <td style="white-space: nowrap">Au cours de la<br>
                question et donc<br>
                avant son échec<br>
                ou sa réussite.</td>
            <td colspan="3">
                L'auteur de la question peut définir des gains
                ou pertes en relatif ou absolu (* ou ±)
                sur des compétences quelconques.<br>
                Contrairement au cas précédents où les calculs sont
                automatiques et identiques, il doit tout paramétrer.
            </td>
        </tr>
        <tr>
            <th></th>
            <th colspan="2" style="font-weight: normal">
                Les valeurs numériques indiquées
                seront adaptées en fonction des expérimentations.
            </th>
        </tr>
    </table>

    <p>
        Les <b>questions possibles</b> sont celles pour lesquelles toutes
        les compétences requises sont acquises (nombre de points supérieur à 1).
        L'étudiant a donc déjà acquis toutes les compétences nécessaires pour répondre à la question.
    </p>

    <p>
        La <b>question proposée</b> à l'étudiant est choisie parmi les possibles,
        et c'est celle qui possède la compétence récoltable la plus faiblement acquise
        (et si égalité, la question la moins souvent posée pour ne pas toujours poser les mêmes).
        L'objectif étant de découvrir ou renforcer cette compétence.
        Souvent les étudiants bloquent sur les questions suivantes car une
        compétence précédente n'est pas suffisamment acquise.
    </p>

    <p>
        Quand on <b>abandonne une question</b> les points des compétences requises
        et des compétences récoltées diminue.
        On ne repropose pas immédiatement une question qui vient d'être abandonnée
        sinon on bouclerait en reproposant constamment la même question.
        Par contre la probabilité de se voir proposer une question permettant
        d'acquérir une compétence qui était nécessaire à la question échouée
        va augmenter afin de faire réviser l'étudiant
        pour qu'il soit mieux préparé quand on lui reproposera la question.
    </p>

    <p>
        La <b>perte sur les compétences</b> requises et récoltées multiplie
        le nombre de points de la compétence par 0.9
        si c'est une requise et 0.5 si c'est une récoltée et peut rendre cette compétence non acquise
        et donc forcer l'étudiant à la revalider.
        Des questions auparavant possibles peuvent donc devenir inaccessibles.
    </p>

    <p>
        Le <b>gain sur les compétences</b> est de 1 pour les points des compétences récoltées
        afin de directement débloquer les questions suivantes.
        Pour les compétences requises le nombre de point est multiplié par 1.1 pour conforter le fait
        qu'elles sont bien acquises.
        Et surtout qu'elles ne soient pas perdues dès la première erreur.
    </p>

    <p>
        Lors de son déroulement, une question peut augmenter les points
        de compétences ni requises ni récoltées que l'étudiant aurait
        démontrées au cours de son travail.
        Ou au contraire enlever des points quand l'étudiant montre
        qu'il n'a pas compris quelque chose qui n'a rien à voir avec la question courante.
        Par exemple si dans une question sur la copie de fichier il utilise la commande pour
        détruire un fichier, il peut perdre des points sur la compétence de destruction
        alors que ce n'est pas le sujet de la question.
    </p>

    <div class="figure">
        Arrivée sur la première question :
        <img src="xxx-1-start.png">
        ... apparaît après quelques secondes :
        <img src="xxx-2-dot-grey.png">
        Après avoir appuyé sur Control pour ouvrir ... :
        <img src="xxx-3-more.png">
        ... apparaît après quelques secondes :
        <img src="xxx-4-dot-blue.png">
        Après avoir appuyé sur Control pour ouvrir ... :
        <img src="xxx-5-ask.png">
        Après avoir appuyé sur entrée, les boîtes apparaissent progressivement :
        <img src="xxx-6-good.png">
        Navigation dans les menus au clavier :
        <img src="xxx-7-menu.png">
        <img src="xxx-8-submenu.png">
        Le disque jaune se rempli de vert en fonction de l'acquisition :
        <img src="xxx-9-subsubmenu.png">
    </div>

    <h2>Interface utilisateur</h2>

    <p>
        Le rectangle noir est le terminal VT100.
        Toutes les commandes, même 'vi' ou 'emacs' sont utilisables.
        C'est l'environnement normal de travail qui fonctionne exactement comme dans la réalité.
    </p>
    <p>
        La partie droite contient des boîtes contenant différentes information,
    </p>
    <p>
        Pour répondre aux questions, l'étudiant n'a donc jamais besoin de quitter le shell
        qui est l'environnement qu'il doit apprendre à maîtriser.
    </p>

    <h2>Création d'un questionnaire</h2>

    <p>
        Les noms des questions et des compétences ne doivent pas commencer
        par un chiffre et ne peuvent contenir que des lettres et des chiffres
        ou bien le caractère souligné «_».
    </p>
    <p>
        La définition d'un questionnaire est faite en créant un fichier par question.
        Ce fichier contient un programme Python définissant complètement la question.
        Par exemple :
    </p>
    <pre>NEEDS = ['CMD_pwd']             # Compétences nécessaires pour répondre.
PROVIDES = []                   # L'exercice ne fournit aucune compétence.
INIT = "cd /etc"                # Mise en place de l'environnement.
def run(S):
  S.ask('''
Lancez la commande pour faire afficher le
&lt;def&gt;chemin&lt;/def&gt; vers &lt;def&gt;répertoire courant&lt;/def&gt;.
''')
  for screen in S.until(last_command_is='pwd'): # Tant que pas la bonne réponse
    if S.expired_timer(10):     # Un indice au bout de 10 secondes.
        S.tip("C'est: &lt;lang&gt;print working directory&lt;/lang&gt;")
</pre>
    </p>
    Ce programme contient les définitions suivantes :
    </p>
    <ul>
        <li>
            <tt>NEEDS = [ 'nom compétence 1', 'nom compétence 2', ...]</tt>
            indique les compétences qui doivent nécessairement être acquises
            afin de pouvoir répondre à la question.
            Les questions sans compétences requises sont les premières proposées.

        <li>
            <tt>PROVIDES = ['nom compétence 3', 'nom compétence 4', ...]</tt>
            indique les compétences que permet d'obtenir la question si l'on y répond correctement.
            Les questions ne permettant d'obtenir aucune nouvelle compétence
            sont des exercices de mise en application de compétences déjà acquises.

        <li>
            <tt>INIT = '# Un script shell exécuté avant que l'étudiant commence'</tt>
            Permet de configurer complètement l'environnement nécessaire pour répondre à la question.
            À chaque nouvelle question un environnement vierge est initialisé
            car les questions sont indépendantes les unes des autres.

        <li>
            <tt>WORDS = {'&lt;CASE&gt;': 'Respectez les majuscules et miniscules.'}</tt>
            Les dictionnaires de toutes les questions sont fusionnés
            afin quelles puissent se partager des messages courants.
            Au moment de l'affichage de <tt>&lt;CASE&gt;</tt>
            il sera remplacé par le message.
            Si vous affichez <tt>&lt;CASE&gt;!</tt> cela affichera
            <tt>&lt;CASE&gt;!</tt> sans modification.
            <br>
            Cette définition est optionnelle.
        </li>


        <li>
            <tt>def run(session)</tt>
            Est la fonction analysant le travail de l'étudiant.
            Elle se termine uniquement si l'étudiant réussit la question
            et dans ce cas le système met à jour les nombres de points
            des compétences requises et récoltées.
            Pour différentes raisons, cette fonction peut être interrompue
            par une exception indiquant l'échec de sa résolution par l'étudiant.
    </ul>
    <p>
        Les outils disponibles pour réaliser la fonction <tt>run</tt> sont les suivants :
    </p>
    <ul>
        <li> <tt>session.until(condition=texte, merge_space=True)</tt>
            <p>
                La condition est de la forme :<br>
                <tt>(not_)?{screen|selection|(last_|next_|)command}_{is|contains|contains_all|contains_one|startswith|endswith}</tt>
            </p>

        </li>
        <li>
            <tt>session.print('texte')</tt> Une information<br>
            <tt>session.course('partie du cours', 'texte')</tt> Le cours<br>
            <tt>session.ask('texte')</tt> La question<br>
            <tt>session.tip(timeout, 'texte')</tt> Un message d'aide<br>
            <tt>session.transient('texte', condition)</tt> Affiché seulement si vrai<br>
            <p>
                <tt>tip</tt> et <tt>transient</tt> retourne True
                la <b>première</b> fois que le message est affiché.
            </p>
            <p>
            Affiche une boite dans la partie droite.
            Le texte peut contenir les tags HTML :
            <ul>
                <li>&lt;path&gt; un chemin vers une entité
                <li>&lt;cmd&gt; une ligne de commande
                <li>&lt;var&gt; un nom de variable shell
                <li>&lt;pat&gt; un pattern
                <li>&lt;regexp&gt; une expression régulière
                <li>&lt;key&gt; une saisie clavier
                <li>&lt;lang&gt; un mot anglais
                <li>&lt;def&gt; un mot important qu'il faudra indexer et mettre en évidence
                <li>&lt;important&gt; une chose important à noter
            </ul>
        <li>
            <tt>session.get_screen(merge_space=True)</tt>
            Retourne une chaîne de caractères représentant l'écran du shell.
            Par défaut les espaces multiples sont remplacés par un espace.
            L'écran suivant :
            <pre>$ cd   ..
$


</pre>
            Va donner la chaîne de caractères : <tt>$ cd ..\n$\n\n\n</tt>
            <br>
            On ne connaît pas la position du curseur texte.

        <li>
            <tt>session.get_last_command(merge_space=True)</tt>
            return the last command launched.
        </li>
        <li>
            <tt>session.get_next_command(merge_space=True)</tt>
            return the command being edited.
        </li>
        <li>
            <tt>session.get_command(merge_space=True)</tt>
            return next command or last command if it is empty.
        </li>
        <li>
            <tt>session.add('competence', point)</tt>
            Ajoute les points indiqués à la compétence.
            La compétence est tronquée à 0 si on ajoute trop de points négatifs.
            Cette méthode est utile seulement dans le cas où la compétence
            n'est ni dans <tt>NEEDS</tt> ni dans <tt>PROVIDES</tt>.

        <li>
            <tt>session.mul('competence', facteur)</tt>
            Fait une multiplication au lieu d'une addition.

        <li>
            <tt>session.reset_timer()</tt>
            Met le timer à 0.
            C'est automatiquement fait quand <tt>until</tt> est utilisé.

        <li>
            <tt>session.expired_timer(42)</tt>
            Retourne vrai au moment où le timer atteint 42 secondes.
            Cela ne remet pas le timer à 0 et on peut donc tester des valeurs autres que 42.
            Il est conseillé de mettre les tests dans l'ordre chronologique.

        <li>
            <tt>session.choice(['item1', 'item2'...])</tt>
            retourne un item choisi aléatoirement.

        <li>
            <tt>session.fail("Un message, il faut recommencer.")</tt>
            Abandonne la question en affichant le message indiqué.

        <li>
            <tt>session.cheat("Un message optionnel.")</tt>
            Abandonne la question en affichant le message indiqué et en disant
            à l'étudiant qu'il n'a pas respecté les consignes.

        <li>
            <tt>session.expect("CMD_xxx")</tt> utilise <tt>until</tt>/<tt>tip</tt>/<tt>transient</tt>/<tt>mul</tt><br>
            Attend que l'étudiant tape la commande 'xxx', lui rappelle
            son nom s'il met trop de temps et le préviens s'il oublie
            l'espace après.
        </li>
        <li>
            <tt>session.press_enter(condition=texte, merge_space=True)</tt>
            Si la condition n'est pas respectée dans les 3 secondes,
            rappelle à l'étudiant qu'il doit lancer la commande.
        </li>
        <li>
            <tt>session.wait(condition=texte, merge_space=True)</tt>
            Attend la réalisation de la condition.
        </li>
    </ul>
    <p>
        Il est possible d'importer des informations d'une autre question :
    </p>
    <pre>from Q04_elsewhere import INIT, get_choices</pre>

    <h2>Compétences à gros grains (générique, haut niveau...)</h2>
    <p>
        Supposons que la compétence G représente le fait d'avoir acquis
        des compétences disjointes A, B et C.
        Dans ce cas, le nombre de points de G est le minimum (ou une autre opération)
        des points de compétence de A, B et C.
        Par exemple la compétence «conjugaison»
        et les compétences conjuguer au «présent», «futur», «passé».
        Dans le cas de Sansoori, pas besoin de faire de questions permettant
        d'obtenir la compétence «conjugaison» puisqu'il suffit de faire un calcul.
    </p>
    <p>
        Si la compétence G représente le fait d'avoir acquis
        des compétences dépendantes A, B et C.
        Dans ce cas il est nécessaire d'ajouter des questions requérant A, B et C
        et permettant de récolter G.
        Par exemple «phrase-simple-présent-1groupe» nécessite les compétences «sujet», «verbe-1groupe»
    </p>
    <p>
        Sansoori proposant toujours des questions qui ont les compétences
        avec le moins de points, cela fera travailler les compétences
        les moins bien acquises.
    </p>
    <p>
        Supposons les dépendances suivantes ou chacune des questions requiert 3 compétences :
    </p>
    <table>
        <tr><td>  </td><td>A</td><td>B</td><td>C</td><td>D</td></tr>
        <tr><td>Q1</td><td> </td><td>*</td><td>*</td><td>*</td></tr>
        <tr><td>Q2</td><td>*</td><td> </td><td>*</td><td>*</td></tr>
        <tr><td>Q3</td><td>*</td><td>*</td><td> </td><td>*</td></tr>
        <tr><td>Q4</td><td>*</td><td>*</td><td>*</td><td> </td></tr>
    </table>
    <p>
        Une fois les 4 questions posées, si l'une des compétences A, B, C, D
        n'est pas acquise alors elle aura perdu 3 fois des points
        alors que les autres auront perdue 2 fois des points et gagné une fois.
        Donc même sans avoir de question portant uniquement sur
        cette compétence, on peut détecter qu'elle n'est pas acquise.
    </p>

    <h2>Administration d'un questionnaire</h2>
    <p>
        Voici quelques commandes :
    </p>
    <ul>
        <li> <tt>make run</tt> lance le questionnaire.</li>
        <li> <tt>make xxx-graph.svg</tt> affiche le graphique SVG des questions.</li>
        <li> <tt>./screenshot</tt> fait des copie d'écran pour la documentation.</li>
        <li> <tt>make xxx-course.html</tt> génère le
            <a target="_blank" href="xxx-course.html">support de cours</a> en HTML.</li>
        <li> <tt>./rename.py OldCompetenceName NewCompetenceName"</tt>
            change le nom de la compétence dans les fichiers et le log.
        </li>
    </ul>

    <h2>Installer Sansoori</h2>
    <p>
        Pour une utilisation en local,
        installer les paquets : <tt>apt install graphviz python3-aiohttp inkscape</tt>
    </p>
    <p>
        Récupérer les sources :<br>
        <tt>git clone https://forge.univ-lyon1.fr/thierry.excoffier/sansoori</tt>
    </p>
    <p>
        L'installation nécessite l'accès à 'root' pour créer le lanceur
        de session d'étudiant avec limitation d'accès et de ressources.
    </p>
    <p>
        Enjoy : <tt>cd sansoori ; make run</tt>
    </p>
    <p>
        La configuration est modifiable dans <tt>config.py</tt>
        et l'on peut aussi y paramétrer le déploiement en production.
    </p>


    <h2>Essayer Sansoori sans l'installer</h2>
    <p>
        Ce n'est possible que si vous avez un compte à l'université Lyon 1.
            <a href="https://sansoori.univ-lyon1.fr/">https://sansoori.univ-lyon1.fr/</a>
